; BITMAP FONT INCLUDE FOR BLITZ2D
; -------------------------------

; This is for the original version of Blitz Basic
; without the 3D commands of blitz3D and without
; the extended windows commands of blitzPlus

;.......................................................................................



; Used internally. If you do wish to access type data
; for a bitmap font, use Object.bmf_data(bitmapfont)
Type bmf_data
	Field fntname$, fntsize, fntstyle
	Field fnttype, bordw
	Field x[255],y[255],w[255],h[255]
	Field img,wd,ht,fntht
	Field forecol[1],bordcol[1],backcol
	Field fores,bords,lspace,vspace,wspace
End Type


; Constants for you to use as you wish
Const BMF_ALIGNLEFT		= 0
Const BMF_ALIGNCENTER	= 1
Const BMF_ALIGNRIGHT	= 2
Const BMF_ALIGNTOP		= 0
Const BMF_ALIGNMIDDLE	= 1
Const BMF_ALIGNBOTTOM	= 2



Function LoadBMF(filename$)
	; filename$	.. The BMF file you want to load

	Local bmf_d.bmf_data
	Local itmp, ifs, ibnk, szexpfile$, iexpf, ifile
	ifile= ReadFile(filename)
	If ifile=0 Then
		Return 0
	End If
	
	szexpfile$ = "~bmpf"
	For i=1 To 15
		szexpfile = szexpfile + Chr(Rand(65,90))
	Next
	
	szexpfile = szexpfile+"."
	If ifile<>0 Then
		bmf_d = New bmf_data
		While Eof(ifile)=0
			Select ReadByte(ifile)
			Case 1
				bmf_d\fnttype = ReadByte(ifile)
				Repeat
					itmp=ReadByte(ifile)
					If itmp=0 Then Exit
					bmf_d\x[itmp] = ReadInt(ifile)
					bmf_d\y[itmp] = ReadInt(ifile)
					bmf_d\w[itmp] = ReadInt(ifile)
					bmf_d\h[itmp] = ReadInt(ifile)
				Until itmp=0
			Case 2
				bmf_d\fntname  = ReadString(ifile)
				bmf_d\fntsize  = ReadInt(ifile)
				bmf_d\fntstyle = ReadInt(ifile)
			Case 3
				bmf_d\forecol[0] = ReadInt(ifile)
				bmf_d\forecol[1] = ReadInt(ifile)
				bmf_d\bordcol[0] = ReadInt(ifile)
				bmf_d\bordcol[1] = ReadInt(ifile)
				bmf_d\backcol    = ReadInt(ifile)
				bmf_d\fores = ReadByte(ifile)
				bmf_d\bords = ReadByte(ifile)
			Case 4
				bmf_d\fnttype = ReadByte(ifile)
				bmf_d\bordw   = ReadInt(ifile)
			Case 10
				szexpfile = szexpfile + ReadString(ifile)
				iexpf = WriteFile(szexpfile)
				ifs = ReadInt(ifile)
				ibnk = CreateBank(ifs)
				ReadBytes ibnk,ifile,0,ifs
				WriteBytes ibnk,iexpf,0,ifs
				FreeBank ibnk
			Case 11
				Exit
			End Select
		Wend
		CloseFile ifile
		CloseFile iexpf
		bmf_d\img = LoadImage(szexpfile)
		If bmf_d\img = 0 Then
			Delete bmf_d
			DeleteFile szexpfile
			DebugLog "** Error loading Font Image. Possible cause: wrong file type?"
			DebugLog "     Remember that Blitz2D does not support PNG files. Save as BMP."
			Return 0
		Else
			MaskImage bmf_d\img,bmf_d\backcol Shr 16 And 255, bmf_d\backcol Shr 8 And 255, bmf_d\backcol And 255
			bmf_d\wd = ImageWidth(bmf_d\img)
			bmf_d\ht = ImageHeight(bmf_d\img)
			DeleteFile szexpfile
			Return Handle(bmf_d)
		End If
	End If
End Function

Function BMFText(BitmapFont, x, y, txt$, align_x=0, align_y=0, wrapwidth=0)
	; BitmapFont  .. A handle to the bitmap font you wish to draw
	; x,y		  .. Coordinates of the text
	; txt$		  .. The text you wish to write
	; align_x	  .. 0 = Left   1 = Center   2 = Right
	; align_y	  .. 0 = Top    1 = Middle   2 = Bottom
	; wrapwidth	  .. Specify a width, and the text will wrap!
	
	txtb$ = ""
	bmf_d.bmf_data = Object.bmf_data(bitmapfont)
	If bmf_d=Null Then Return
	fntht=0
	For i=0 To 255
		If bmf_d\h[i]>fntht Then fntht=bmf_d\h[i]
	Next
	i=BMFGetLines(bitmapfont, txt, wrapwidth)
	If align_y=1 Then yy=-(fntht*i + bmf_d\vspace*(i-1))/2
	If align_y=2 Then yy=-(fntht*i + bmf_d\vspace*(i-1))
	
	For i=1 To Len(txt)
		char$ = Mid(txt,i,1)
		If char<>" " And char<>Chr(13)
			Select bmf_d\fnttype
			Case 0
				If Asc(char)<Asc("0") Or Asc(char)>Asc("9") Then char=""
			Case 1
				char=Upper(char)
				If (Asc(char)<Asc("0") Or Asc(char)>Asc("9")) And (Asc(char)<Asc("A") Or Asc(char)>Asc("Z")) Then char=""
			Case 2
				If (Asc(char)<Asc("0") Or Asc(char)>Asc("9")) And (Asc(Upper(char))<Asc("A") Or Asc(Upper(char))>Asc("Z")) Then char=""
			Case 3
				If Asc(char)=>127 Then char=""
			Case 4
			End Select
		End If
		If char<>"" Then
			txtb=txtb+char
			If char=" " Then oldi=i-1:oldw=w:w=w+bmf_d\wspace
			w = w + bmf_d\w[Asc(char)]+1+bmf_d\lspace
			If (w>wrapwidth And oldw<>0 And wrapwidth<>0) Or i=Len(txt) Or char=Chr(13)
				ww=w
				If (w>wrapwidth And oldw<>0 And wrapwidth<>0)
					txtb = Left(txtb,Len(txtb)-(i-oldi))
					ww=oldw
					i=oldi+1
				End If
				xx=0
				If align_x=1 Then xx=-ww/2
				If align_x=2 Then xx=-ww
				For ii=1 To Len(txtb)
					char$ = Mid(txtb,ii,1)
					DrawImageRect bmf_d\img, x+xx, y+yy, bmf_d\x[Asc(char)], bmf_d\y[Asc(char)], bmf_d\w[Asc(char)]+1, bmf_d\h[Asc(char)+1]
					xx=xx+bmf_d\w[Asc(char)]+1+bmf_d\lspace
					If char=" " Then xx=xx+bmf_d\wspace
				Next
				txtb=""
				w=0:yy=yy+fntht+bmf_d\vspace:oldw=0
			End If
		End If
	Next
	
End Function


Function BMFGetLines(bitmapfont, txt$, wrapwidth)
	; Returns the number of lines that the text takes up, when
	; wrapped to a certain width
	
	bmf_d.bmf_data = Object.bmf_data(bitmapfont)
	lines=0:txtb$="":w=0:oldw=0

	If bmf_d<>Null Then
		For i=1 To Len(txt)
			char$ = Mid(txt,i,1)
			If char<>" " And char<>Chr(13)
				Select bmf_d\fnttype
				Case 0
					If Asc(char)<Asc("0") Or Asc(char)>Asc("9") Then char=""
				Case 1
					char=Upper(char)
					If (Asc(char)<Asc("0") Or Asc(char)>Asc("9")) And (Asc(char)<Asc("A") Or Asc(char)>Asc("Z")) Then char=""
				Case 2
					If (Asc(char)<Asc("0") Or Asc(char)>Asc("9")) And (Asc(Upper(char))<Asc("A") Or Asc(Upper(char))>Asc("Z")) Then char=""
				Case 3
					If Asc(char)=>127 Then char=""
				Case 4
				End Select
			End If
			If char<>"" Then
				txtb=txtb+char
				If char=" " Then oldi=i-1:oldw=w:w=w+bmf_d\wspace
				w = w + bmf_d\w[Asc(char)]+1+bmf_d\lspace
				If (w>wrapwidth And oldw<>0 And wrapwidth<>0) Or i=Len(txt) Or char=Chr(13)
					If w>wrapwidth And oldw<>0 And wrapwidth<>0
						i=oldi+1
					End If
					lines=lines+1
					txtb=""
					w=0:oldw=0
				End If
			End If
		Next
	End If
	Return lines
End Function


Function BMFFontHeight(bitmapfont)
	; Returns the maximum character height of the selected bitmapfont
	; Do not confuse with BMFFontSize which returns the actual font size
	; used to create the Bitmap Font in the designer

	fntht=0
	bmf_d.bmf_data = Object.bmf_data(bitmapfont)
	If bmf_d<>Null
		For i=0 To 255
			If bmf_d\h[i]>fntht Then fntht=bmf_d\h[i]
		Next
		Return fntht
	End If
End Function


Function BMFStringWidth(bitmapfont, txt$, wrapwidth=0)
	; Returns the total width of the bitmapfont text
	; Specify a wrapwidth if you wish to clip the width
	
	bmf_d.bmf_data = Object.bmf_data(bitmapfont)
	If bmf_d=Null Then Return 0
	
	txtb$=""
	For i=1 To Len(txt)
		char$ = Mid(txt,i,1)
		If char<>" " And char<>Chr(13)
			Select bmf_d\fnttype
			Case 0
				If Asc(char)<Asc("0") Or Asc(char)>Asc("9") Then char=""
			Case 1
				char=Upper(char)
				If (Asc(char)<Asc("0") Or Asc(char)>Asc("9")) And (Asc(char)<Asc("A") Or Asc(char)>Asc("Z")) Then char=""
			Case 2
				If (Asc(char)<Asc("0") Or Asc(char)>Asc("9")) And (Asc(Upper(char))<Asc("A") Or Asc(Upper(char))>Asc("Z")) Then char=""
			Case 3
				If Asc(char)=>127 Then char=""
			Case 4
			End Select
		End If
		If char<>"" Then
			txtb=txtb+char
			If char=" " Then oldi=i-1:oldw=w:w=w+bmf_d\wspace
			w = w + bmf_d\w[Asc(char)]+1+bmf_d\lspace
			If (w>wrapwidth And oldw<>0 And wrapwidth<>0) Or i=Len(txt) Or char=Chr(13)
				If ww<w Then ww=w
				If (w>wrapwidth And oldw<>0 And wrapwidth<>0)
					i=oldi+1
				End If
				txtb=""
				w=0:oldw=0
			End If
		End If
	Next
	If ww>wrapwidth And wrapwidth<>0 Then ww=wrapwidth
	Return ww
End Function


Function FreeBMF(bitmapfont)
	; Deletes a bitmapfont and frees up the memory it uses
	
	bmf_d.bmf_data = Object.bmf_data(bitmapfont)
	If bmf_d=Null Then Return 0
	If bmf_d\img Then FreeImage bmf_d\img
	Delete bmf_d
	Return 0
End Function


Function BMFGetFontFace$(bitmapfont)
	; If the font was designed specifically using the Bitmap Font Editor
	; this function will tell you what font name was used to create it
	
	bmf_d.bmf_data = Object.bmf_data(bitmapfont)
	If bmf_d<>Null Then Return bmf_d\fntname
End Function


Function BMFGetFontSize(bitmapfont)
	; If the font was designed specifically using the Bitmap Font Editor
	; this function will tell you what size font was used to create it
	
	; This is NOT the same as BMFFontHeight, which returns the actual
	; height that the bitmap font takes up on screen.
	
	bmf_d.bmf_data = Object.bmf_data(bitmapfont)
	If bmf_d<>Null Then Return bmf_d\fntsize
End Function


Function BMFGetFontStyle(bitmapfont)
	; If the font was designed specifically using the Bitmap Font Editor
	; this function will tell you what style font it is. Flags are additive
	; so Bold + Italic = 3
	
	; 0 = No formatting
	; 1 = Bold
	; 2 = Italic
	; 4 = Antialiased
	
	bmf_d.bmf_data = Object.bmf_data(bitmapfont)
	If bmf_d<>Null Then Return bmf_d\fntstyle
End Function


Function BMFGetCharSet(bitmapfont)
	; Returns an integer denoting what set of characters the bitmap font
	; contains. A set always contains the SPACE character (chr 32), the
	; Carriage Return (chr 13), and the following:
	
	; 0 = 0-9
	; 1 = 0-9 A-Z
	; 2 = 0-9 A-Z a-z
	; 3 = 0-9 A-Z a-z + punctuation
	; 4 = 0-9 A-Z a-z + punctuation + extended characters
	
	bmf_d.bmf_data = Object.bmf_data(bitmapfont)
	If bmf_d<>Null Then Return bmf_d\fnttype
End Function


Function BMFConvertToCharset$(bitmapfont,txt$)
	; Converts characters to how they would look if part of the
	; character set of the bitmap font.
	
	; For example, if you submit a lower case letter and the bitmapfont only
	; contains 0-9 A-Z then it will be converted to upper case. If it is
	; a symbol that is not used, it will return blank.
	
	; Note that spaces and carriage returns (chr 32 + chr 13) are part
	; of every character set
	
	bmf_d.bmf_data = Object.bmf_data(bitmapfont)
	If bmf_d=Null Then Return
	
	Local txtb$=""
	For i=1 To Len(txt)
		char$ = Mid(txt,i,1)
		If char<>" " And char<>Chr(13)
			Select bmf_d\fnttype
			Case 0
				If Asc(char)<Asc("0") Or Asc(char)>Asc("9") Then char=""
			Case 1
				char=Upper(char)
				If (Asc(char)<Asc("0") Or Asc(char)>Asc("9")) And (Asc(char)<Asc("A") Or Asc(char)>Asc("Z")) Then char=""
			Case 2
				If (Asc(char)<Asc("0") Or Asc(char)>Asc("9")) And (Asc(Upper(char))<Asc("A") Or Asc(Upper(char))>Asc("Z")) Then char=""
			Case 3
				If Asc(char)=>127 Then char=""
			Case 4
			End Select
		End If
		txtb=txtb+char
	Next
	
	Return txtb
End Function


Function BMFGetVerticalSpacing(bitmapfont, vspacing=0)
	; Gets the amount of vertical spacing between each line of text, of the specified BMF
	
	bmf_d.bmf_data = Object.bmf_data(bitmapfont)
	If bmf_d=Null Then Return
	
	Return bmf_d\vspace
End Function

Function BMFGetLetterSpacing(bitmapfont, lspacing=0)
	; Gets the amount of horizontal spacing between each letter, of the specified BMF
	
	bmf_d.bmf_data = Object.bmf_data(bitmapfont)
	If bmf_d=Null Then Return
	
	Return bmf_d\lspace
End Function

Function BMFGetWordSpacing(bitmapfont, wspacing=0)
	; Gets the amount of horizontal spacing between each word, of the specified BMF
	; This is additive to the width of the SPACE character.
	
	bmf_d.bmf_data = Object.bmf_data(bitmapfont)
	If bmf_d=Null Then Return
	
	Return bmf_d\wspace
End Function



Function BMFSetVerticalSpacing(bitmapfont, vspacing=0)
	; Sets the amount of vertical spacing between each line of text, of the specified BMF
	
	bmf_d.bmf_data = Object.bmf_data(bitmapfont)
	If bmf_d=Null Then Return
	
	bmf_d\vspace = vspacing
End Function

Function BMFSetLetterSpacing(bitmapfont, lspacing=0)
	; Sets the amount of horizontal spacing between each letter, of the specified BMF
	
	bmf_d.bmf_data = Object.bmf_data(bitmapfont)
	If bmf_d=Null Then Return
	
	bmf_d\lspace = lspacing
End Function

Function BMFSetWordSpacing(bitmapfont, wspacing=0)
	; Sets the amount of horizontal spacing between each word, of the specified BMF
	; This is additive to the width of the SPACE character.
	
	bmf_d.bmf_data = Object.bmf_data(bitmapfont)
	If bmf_d=Null Then Return
	
	bmf_d\wspace = wspacing
End Function